%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                               %
% 1. Schreibe ein Prädikat generate_all/1, welches eine natürliche Zahl als     %
% Argument nimmt (Bsp.:generate_all(5)) und alle grammatischen Sätze dieser     %
% Länge generiert.                                                              %
% 2. Die Sätze werden an das Prädikat parse/1 weitergereicht, so dass alle      %
% Sätze sowie alle Ableitungsbäume auf dem Bildschirm ausgegeben werden.        %
% 3. Schreibe ein zweistelliges Prädikat generate_all/2, das zwei Zahlen        %
% als Argument nimmt (Bsp.generate_all(5,7)) und alle Sätze generiert,          %
% deren Länge im Intervall der beiden Zahlen liegt.                             %
% Schreiben sie durchnummerierte Beispielsätze in ihre Wissensbasis             %
% (ex/2,siehe Übung zu Kapitel 9). Schreibe ein Prädikat parse_all/0, das       %
% alle Beispielsätze der Wissensbasis parst.                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Grammatikregeln mit Parser
s(s(NP, VP)) --> np(NP,(nom,Num,_)), vp(VP,Num).
np(np(Det, N),KNG) --> det(Det, KNG), n(N, KNG).
vp(vp(V, NP),Num) --> v(V, Num), np(NP, (akk,_,_)).

% Lexikon:
det(det(der),(nom,sing,mas)) --> [der].
det(det(den),(akk,sing,mas)) --> [den].
det(det(die),(_,sing,fem)) --> [die].
det(det(das),(_,sing,neu)) --> [das].
det(det(die),(_,plur,_)) --> [die].
det(det([]),(_,plur,_)) --> [].
n(n(maus),(_,sing,fem)) --> [maus].
n(n(maeuse),(_,plur,_)) --> [maeuse].
n(n(katze),(_,sing,fem)) --> [katze].
n(n(katzen),(_,plur,_)) --> [katzen].
n(n(hund),(_,sing,mas)) --> [hund].
n(n(hunde),(_,plur,mas)) --> [hunde].
n(n(pferd),(_,sing,neu)) --> [pferd].
n(n(pferde),(_,plur,neu)) --> [pferde].
v(v(jagt),sing) --> [jagt].
v(v(jagen),plur) --> [jagen].

%%% Lösung

% generate_all/1

generate_all(N) :- length(S,N),                                 % generiert alle Sätze mit der Länge N,
                   parse(S),                                    % parset diese und gibt sie aus, solange
                   fail.                                        % bis keine weiteren Sätze möglich sind.
                   
generate_all(_).                                                %  nimmt die eingegbene Zahl als Arguemnt


%generate_all/2

generate_all(Max,Max) :- generate_all(Max).                     % Ausgabe erfolgt, bis man bei Max. angelagt ist
generate_all(Min,Max) :- Min =< Max,                            % es werden alle Sätze zwischen dem Min und Max generiert,
                         generate_all(Min),                     % angefangen beim Minimum,
                         nl,                                    % getrennt durch jeweils eine neue Zeile,
                         NeuMin is Min+1,                       % aufwärts ab Min, sodass die neue Zahl in NeuMin  gespeichert wird und
                         generate_all(NeuMin, Max).             % rekursiv aufgerufen


% parse_all

parse_all :- test(_),fail.                                      % parst alle Bsp.sätze aus der Wissenbasis, bis keine mehr vorhanden sind
parse_all.                                                      % Ausgabe


% (Beschreibung hierfür in den Lösungen zu Vorlesung 8)
% parse/1 

parse(S) :- s(T, S, []),
            pprint_list(S),
            nl,
            pprint(T).


% pprint_list/1

pprint_list([]).
pprint_list([H|T]) :- write(H),
                      tab(1),
                      pprint_list(T).



% pprint/1

pprint(Term):- pprint(Term ,0).

pprint(Term ,N):-
             Term =.. [F| Args ] ,
             tab(N),
             write(F),
             nl,
             N1 is N+3 ,
             pprintl(Args ,N1).

pprintl([H|T] ,N):-
             pprint(H,N),
             pprintl(T,N).
             pprintl([] ,_).

