%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                       
%                                                                       %
% Übung:  roter/grüner Cut                                              %
% Handelt es sich bei folgendem Cut um einen roten oder grünen?         %                 
%                                                                       %
%   append([],L,L):- !.                                                 %
%   append([H|T1],L,[H|T2]):- append(T1,L,T2).                          %
%                                                                       %
% Tipp: Was passiert bei der Anfrage ?- append(X,Y,[a,b,c]).?           %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   


%%% Lösung:

% Es handelt sich hierbei um einen roten Cut. 
% Stellt man die Anfrage ?- append(X,Y,[a,b,c])., so erhält man das Ergebnis X = [], Y = [a, b, c]..
% Ohne den Cut jedoch würde das Ergebnis so aussehen: X = [], Y = [a, b, c] ;
%                                                     X = [a], Y = [b, c] ;
%                                                     X = [a, b], Y = [c] ;
%                                                     X = [a, b, c], Y = [] ;
% Dies liegt daran, dass durch den Cut die erstmögliche Variablenbegelung ausgegeben wird 
% und danach nicht nach weiteren Belegungen gesucht wird. 
% Ohne den Cut werden jedoch alle möglichen Variablenbelegungen gesucht,
% weswegen mehr Ergebnisse als bei der Version mit dem Cut ausgegeben werden. 
